package raincoat.api;

import raincoat.sql.AlgebraOperator;


public class OperationCost {
	/*
	 * A naive implementation to get things going
	 */
	public static Double getCost(AlgebraOperator operation, Integer numTuples) {
		switch (operation) {
		
		case AGGREGATOR:
			return new Double(2*numTuples);
		case SELECT:
			return new Double(numTuples);
		case JOIN:
			return new Double(Math.pow(numTuples, 2));
		case PROJECT:
			return new Double(numTuples);
		case SOURCE:
			// since this cost cannot be ommited
			return new Double(0);
		default:
			throw new IllegalArgumentException
			("The operation "+operation+" cost is not defined in class OperationCost");
		}
		
		
	}

}
