package raincoat.api;

import java.util.List;

public interface PipelinedNode extends RATreeNode {
	
	/**
	 * Returns a list of the RATreeNodes that are pipelined.
	 * 
	 * @return the pipelined RATreeNodes as a list in the order they 
	 * are executed 
	 */
	public List<RATreeNode> getPipelinedNodes();
	
	/**
	 * A method used to explicitly check if the node at hand 
	 * is pipelined or not.
	 * 
	 * @return true if getPipelinedNodes() contains more than one RATreeNode
	 * false if not
	 */
	public Boolean isPiped();

}
