package raincoat.kafka;

import java.io.UnsupportedEncodingException;
import java.util.List;

import backtype.storm.spout.Scheme;
import backtype.storm.tuple.Fields;
import backtype.storm.tuple.Values;

public class RaincoatScheme implements Scheme{
	
	private Fields _out;
	public RaincoatScheme(Fields outFields) {
		_out = outFields;
	}

    public List<Object> deserialize(byte[] bytes) {
        try {
        	Values val = new Values();
        	String[] inputs = new String(bytes, "UTF-8").split("\\|");
        	for (String input : inputs) {
        		if (input.charAt(0) == '\"' || 
        				input.charAt(0) == '\'') {
        			val.add(input.substring(1, input.length()-1));
        		} else {
        			val.add(Integer.parseInt(input));
        		}
        	}
            return val;
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException(e);
        }
    }

    public Fields getOutputFields() {
        return _out;
    }

}
