package raincoat.operations;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import raincoat.api.Window;
import raincoat.storm.Tuples;


import backtype.storm.tuple.Fields;
import backtype.storm.tuple.Tuple;
import backtype.storm.tuple.Values;


/**
 * Count assumes that tuples have been filtered before
 * doing count. This decision simplifies the design of
 * the Count class
 * 
 * @author gronnbeck
 *
 */
public class Count extends MultipleTuplesOperation {

	private Values values;
	private Fields fields;
	private Tuples anchoredTuples;
	
	
	public Count() {
		
	}

	@Override
	public void init(Map conf, Window<?> window) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public boolean performOperation(Tuples tuples) {
		Values values = new Values();
		values.add(tuples.size());
		this.values = values;
		
		anchoredTuples = new Tuples(tuples);
		
		return true;
	}

	@Override
	public List<Values> getOutputValues() {
		List<Values> out = new ArrayList<Values>();
		out.add(this.values);
		return out;
	}

	@Override
	public Fields getFields() {
		return this.fields;
	}

	@Override
	public Tuples getAnchoringTuples() {
		return anchoredTuples;
	}

}
