package raincoat.operations;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import raincoat.api.Window;
import raincoat.storm.Tuples;


import backtype.storm.tuple.Fields;
import backtype.storm.tuple.Tuple;
import backtype.storm.tuple.Values;

@SuppressWarnings("serial")
public class Projection extends SingleTupleOperation {
	
	private Fields fields;
	private Values values;
	private Tuples anchoredTuples;
	
	@Override
	public void init(Map conf, Window<?> window) {
		
	}
	
	public Projection(Fields fields) {
		this.fields = fields;
	}
	
	@Override
	public boolean performOperation(Tuple tuple) {
		Values values = new Values();
		for (String field : this.fields.toList()) {
			values.add(tuple.getValueByField(field));
		}
		this.values = values;
		
		anchoredTuples = new Tuples();
		anchoredTuples.add(tuple);
		
		return true;
	}

	@Override
	public List<Values> getOutputValues() {
		List<Values> out = new ArrayList<Values>();
		out.add(this.values);
		return out;
	}

	@Override
	public Fields getFields() {
		return fields;
	}

	@Override
	public Tuples getAnchoringTuples() {
		return anchoredTuples;
	}


}
