package raincoat.ratree;

import java.util.ArrayList;
import java.util.List;

import raincoat.api.RATreeNode;
import raincoat.api.RaincoatGrouping;
import raincoat.sql.AlgebraOperator;
import raincoat.sql.Condition;

public class JoinNode extends Node {
	
	private Condition condition;
	
	public Condition getCondition() {
		return this.condition;
	}
	
	public JoinNode(String identifier, Condition condition, List<String> outputTuples) {
		super(identifier, AlgebraOperator.JOIN, outputTuples);
		this.condition = condition;
	}

	public JoinNode(Condition condition, List<String> outputTuples) {
		super(AlgebraOperator.JOIN, outputTuples);
		this.condition = condition;
	}

	public List<String> getOutputTuples() {
		return getInputTuples();
	}

	@Override
	public List<String> getSourceIdentifier() {
		List<RATreeNode> sources = getSources();
		
		List<String> sourceIds = new ArrayList<String>();

		for (RATreeNode node : sources) {
			if(node.containsField(condition.getFieldB().getValue().toString()))
				sourceIds.add(node.getIdentifier());
			if(node.containsField(condition.getFieldA().getValue().toString()))
				sourceIds.add(node.getIdentifier());
		}
		
		return sourceIds;
	}
	
	@Override
	public RaincoatGrouping getGrouping() {
		return RaincoatGrouping.FIELDS;
	}
}
