package raincoat.ratree;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import raincoat.api.RATreeNode;
import raincoat.sql.AlgebraOperator;

public class ProjectNode extends Node {

	List<String> outs;
	public ProjectNode(List<String> outputTuples) {
		super(AlgebraOperator.PROJECT, outputTuples);
		outs = outputTuples;
	}

	@Override
	public List<String> getSourceIdentifier() {
		List<String> sourceIds = new ArrayList<String>(); 
		List<RATreeNode> sources = getSources();
		
		for (String field : getOutputTuples()) {
			for (RATreeNode node : sources) {
				if(node.containsField(getField(field)))
					sourceIds.add(node.getIdentifier());
			}	
		}
		return sourceIds;
	}
	
	@Override
	public List<String> getOutputTuples() {
		return outs;
	}
	
	private String getField(String field) {
		String[] split = field.split(":");
		if(split.length > 1)
			return split[1];
		else
			return field;
		
	}
	
}
