package raincoat.ratree;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;

import raincoat.sql.AlgebraOperator;


public class SourceNode extends Node {
	private String name;
	private Map<String, String> options;
	private String sourceType;
		
	public String getName() {
		return name;
	}

	public Map<String, String> getOptions() {
		return options;
	}

	public String getSourceType() {
		return sourceType;
	}
	
	public SourceNode(String identifier, List<String> outputTuples, 
			String name, String sourceType, 
			Map<String, String> options) {
		super(identifier, AlgebraOperator.SOURCE, outputTuples);
		init(name, options, sourceType);
	}

	public SourceNode(List<String> outputTuples, String name, 
			String sourceType, Map<String, String> options) {
		super(AlgebraOperator.SOURCE, outputTuples);
		init(name, options, sourceType);
	}
	
	private void init(String name, Map<String, String> options, String sourceType) {
		this.name = name;
		this.options = options;
		this.sourceType = sourceType;
	}

	@Override
	public List<String> getSourceIdentifier() {
		ArrayList<String> ids = new ArrayList<String>();
		ids.add(this.getIdentifier());
		return ids;
	}

}
