package raincoat.ratree;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import raincoat.sql.AlgebraOperator;

public class WindowNode extends Node {
	
	public enum WindowType {
		SECONDS,
		TUPLES
	}
	
	private int tickInterval;
	private WindowType windowType;
	private int windowSize;

	public int getTickInterval() {
		return this.tickInterval;
	}

	public WindowType getType() {
		return this.windowType;
	}
	
	public int getWindowSize() {
		return this.windowSize;
	}

	public WindowNode(int tickInterval, WindowType windowType, int windowSize) {
		super(AlgebraOperator.WINDOW, null);
		this.tickInterval = tickInterval;
		this.windowType = windowType;
		this.windowSize = windowSize;
	}

	@Override
	public List<String> getSourceIdentifier() {
		return new ArrayList<String>();
	}
	
	@Override
	public String toString() {
		return this.getOperator().toString() + 
				": tickInterval, windowSize, windowType: " +
				"[" + tickInterval + ", " + windowSize + ", " + 
				windowType.toString() + "]";
	}
}
