package raincoat.sql;

public abstract class Tokenstream {
	final static int OPERATION = -95;
	final static int OPERATOR = -96;
	final static int DOUBLE = -97;
	final static int NAME = -98;
	final static int STRING = -99;
	final static int EOF = -100;
	final static int SELECT = -101;
	final static int WHERE = -102;
	final static int GROUP_BY = -103;
	final static int EVERY = -104;
	final static int SIZE = -107;
	final static int FROM = -105;
	final static int AGGREGATOR = -106;
	
	final static int CREATE = -110;
	final static int WITH = -111;
	final static int SECONDS = -112;
	final static int TUPLES = -113;
	final static int FIELDS = -114;
	final static int STREAM = -115;
	final static int TYPE = -116;
	final static int OPTIONS = -117;
	final static int DATE = -118;
	final static int STATIC = -119;
	
	public int tok;
	public double nval;
	public String sval;
	
	abstract public void next();
	
	public IllegalArgumentException parseerror(String msg) {
		return new Parseerror(msg + " but found " + this);
	}
	
	class Parseerror extends IllegalArgumentException {
		
		private static final long serialVersionUID = -6760739295316639004L;

		public Parseerror(String s) {
			super(s);
		}
	}
}
