package raincoat.storm;

import java.util.Random;

import raincoat.api.Stream;

import backtype.storm.tuple.Fields;
import backtype.storm.tuple.Values;
import backtype.storm.utils.Utils;

/**
 * An example of how one can implement a Stream. This is a modified
 * example of the well known RandomSentenceSpout example. 
 * 
 * @author gronnbeck
 *
 */
public class RandomSentenceStream implements Stream {
	
	Random rand;

	@Override
	public Values nextTuple() {
		  Utils.sleep(100);
	        String[] sentences = new String[] {
	            "the cow jumped over the moon",
	            "an apple a day keeps the doctor away",
	            "four score and seven years ago",
	            "snow white and the seven dwarfs",
	            "i am at two with nature"};
	        
	        int[] values = new int[] {
	        		1, 2, 3, 4, 5
	        };
	        int rnd = this.rand.nextInt(sentences.length);
	        String sentence = sentences[rnd];
	        int value = values[rnd];
		return new Values(sentence, value);
	}

	@Override
	public Fields outputFields() {
		return new Fields("word", "value");
	}

	@Override
	public void init() {
		this.rand = new Random();
		
	}

	@Override
	public String getStreamName() {
		return "randomSentenceStream";
	}
}
