package raincoat.storm;

import java.util.Map;

import raincoat.api.Window;
import raincoat.windows.SlidingTimedWindow;

import backtype.storm.task.OutputCollector;
import backtype.storm.task.TopologyContext;
import backtype.storm.topology.OutputFieldsDeclarer;
import backtype.storm.topology.base.BaseRichBolt;
import backtype.storm.tuple.Fields;
import backtype.storm.tuple.Tuple;

public class StatisticsBolt extends BaseRichBolt {
	
	private Fields _fields;
	private Window<Tuple> _window;	
	private OutputCollector _collector;
	public StatisticsBolt(Fields fields) {
		_fields = fields;
	}

	@Override
	public void prepare(Map stormConf, TopologyContext context,
			OutputCollector collector) {
		_window = new SlidingTimedWindow(8, 2);
		_collector = collector;
	}

	@Override
	public void execute(Tuple input) {
		_window.addTuple(input);
		if (input.getSourceStreamId().equals("__tick")) {
			System.err.println("\n\n REPORT \n\n\tWindow size:" + _window.getTuples().size() + "\n");
			
			_window.advanceWindow();
			_window.evictExpiredTuples();
			return;
		}
		
		_collector.emit(input, input.getValues());
		
	}

	@Override
	public void declareOutputFields(OutputFieldsDeclarer declarer) {
		declarer.declare(_fields);
	}

}
