package raincoat.storm;

import java.util.Map;
import java.util.UUID;

import raincoat.api.Stream;

import backtype.storm.spout.SpoutOutputCollector;
import backtype.storm.task.TopologyContext;
import backtype.storm.topology.OutputFieldsDeclarer;
import backtype.storm.topology.base.BaseRichSpout;

public class StreamSpout extends BaseRichSpout {

	SpoutOutputCollector collector;
    Stream stream;    
    
    /**
     * Create a spout which uses a stream as a Spout.
     * A stream can fetch data from a distributed queue, convert data from that queue into
     * tuples and pass them to the Storm topology.
     * 
     * @param stream predfined source of tuples
     * 
     */
    public StreamSpout(Stream stream) {
    	this.stream = stream;
    }
    
    @Override
    public void open(Map conf, TopologyContext context, SpoutOutputCollector collector) {
        this.collector = collector;
        this.stream.init();
    }

    @Override
    public void nextTuple() {
    	this.collector.emit(this.stream.nextTuple(), UUID.randomUUID());
   
   
    }        

    @Override
    public void ack(Object id) {
    }

    @Override
    public void fail(Object id) {
    }

    @Override
    public void declareOutputFields(OutputFieldsDeclarer declarer) {
        declarer.declare(this.stream.outputFields());
    }

}
