package raincoat.testsuit.performance;

import java.util.Random;
import java.util.UUID;

import backtype.storm.tuple.Values;

public class FacebookDataGenerator extends LoadDataGenerator {
	
	public FacebookDataGenerator(long seed) {
		super(seed);
	}

	@Override
	public Values next() {
		RandomGeoTag geotag = new RandomGeoTag();
		
		int nextUsername = rand.nextInt(usernames.size());
		String username = usernames.get(nextUsername);
		if (nextUsername < usernames.size()/3) {
			username = usernames.get(0);
		}
		
		String message = getMessage();
		
		int nextMention = rand.nextInt(usernames.size());
		String mention = usernames.get(nextMention);
		if (nextMention < usernames.size()/3) {
			mention = "dummy";
		}
		
		String link = UUID.randomUUID().toString().split("-")[0];
		return new Values(username, message, geotag.toString(), mention, link);
	}

	@Override
	public boolean hasNext() {
		return true;
	}

	@Override
	public void forceStartIndex(int i) {
		throw new IllegalArgumentException(
				"Not implemented yet.. Sorry");
	}

}
