package raincoat.testsuit.performance;

import java.util.Properties;

import backtype.storm.tuple.Values;

import kafka.javaapi.producer.Producer;
import kafka.javaapi.producer.ProducerData;
import kafka.producer.ProducerConfig;

public class KafkaProducer {

	public static void main(String[] args) {

		String topic = args[1];
		int productionRate = Integer.parseInt(args[2]);
		
		DataGenerator dataGen = 
				new TPCHDataReader(topic);

		Properties props = new Properties();
		props.put("zk.connect", args[0]);
		props.put("serializer.class", 
				"kafka.serializer.StringEncoder");
		ProducerConfig config = new ProducerConfig(props);
		Producer<String, String> producer = 
				new Producer<String, String>(config);

		while(dataGen.hasNext()) {
			Values values = dataGen.next();
			ProducerData<String, String> data = 
					new ProducerData<String, String>(
							topic, 
							valuesAsString(values)
					);
			producer.send(data);
			
			if (productionRate > 0)
				PerformanceTestSuit.sleep(productionRate);
		}
	}
	
	private static String valuesAsString(Values values) {
		String valuesString = "";
		for (Object value : values) {
			if (value instanceof String) {
				valuesString += "\""+value+"\"";	
			}
			else {
				valuesString += value;
			}
			valuesString += "|";
		}
		return valuesString.trim();
	}

}	
