package raincoat.testsuit.performance;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import backtype.storm.tuple.Values;

public class TPCHDataReader implements DataGenerator {
	BufferedReader br;
	String current;
	
	public static void main(String[] args) {
		DataGenerator dg = new TPCHDataReader("part");
		dg.forceStartIndex(20);
		Values vals = dg.next();
		System.out.println(vals.get(0));
	}
	
	public TPCHDataReader(String tableName) {
		try {
			Map<String, String> env = System.getenv();
			String path = env.get("TPCH_TABLES");
			if (path == null) path = "../";
			FileReader reader = new FileReader(path+"/tables/"+tableName+".tbl");
			br = new BufferedReader(reader);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	public Values next() { 
		List<Object> vals = new ArrayList<Object>();
		Object[] input = current.split("\\|");
	
		for (int i = 0; i < input.length; i++) {
			Object val = input[i];
			try {
				Integer integer = (Integer)Integer.valueOf((String)val);
				vals.add(integer);
			} catch(IllegalArgumentException ignore) {
				vals.add((String)val);
			}
		}
		Values values = new Values();
		values.addAll(vals);
		return values;
		
	}

	@Override
	public boolean hasNext() {
		try {
			current = br.readLine();
			if(current == null)
				return false;
			return true;
		} catch (IOException e) {
			return false;
		}		
	}

	@Override
	public void forceStartIndex(int i) {
		while((i--) > 0)
			hasNext();
	}
}