package raincoat.testsuit.performance;

import java.util.List;
import java.util.Random;

import backtype.storm.tuple.Values;

public class TwitterDataGenerator extends LoadDataGenerator {

	public TwitterDataGenerator(long seed) {
		super(seed);
	}
	
	@Override
	public Values next() {
		RandomGeoTag geotag = new RandomGeoTag();
		String username = usernames.get(rand.nextInt(usernames.size()));
		String message = getMessage();
		String hashtag = hashtags.get(rand.nextInt(hashtags.size()));
		String mention = usernames.get(rand.nextInt(usernames.size()));
		return new Values(username, geotag.toString(), message, hashtag, mention);
	}

	@Override
	public boolean hasNext() {
		return true;
	}

	
	@Override
	public void forceStartIndex(int i) {
		throw new IllegalArgumentException(
				"Sorry not implemented");
	}
	
	
	public static void main(String[] args) {
		DataGenerator twitterGen = new TwitterDataGenerator(System.currentTimeMillis());
		for (int i = 0; i < 10; i++) {
			System.out.println(twitterGen.next());
		}
	}
	
	

}
