package raincoat.util;

import raincoat.api.RATreeNode;
import raincoat.ratree.Node;

/**
 * Simple DFS class using Template pattern for a reusable
 * traversing a tree using the DFS algorithms.
 * 
 * @author gronnbeck
 *
 */
public abstract class DFS {

	/**
	 * Traversing a tree from the root node passed as input
	 * @param root the root node of a tree
	 */
	public void traverserTree(RATreeNode root) {
		for (RATreeNode child : root.getChildren()) {
			traverserTree(child);
		}
		execute(root);
	}
	
	/**
	 * Method that is executed on a node
	 * @param root node to execute on
	 */
	protected abstract void execute(RATreeNode root);

}
